function d = InverseTransformation (distances, width)
  bucket{1} = 0;
  bucket_width = 0; 
  m=1;
  l=1;
##----divide_buckets-----
  do  
    do    
      bucket_width += width;
      j = find( bucket_width - width < distances & distances <= bucket_width);
    until (j >= 1)    
    i=1;
    if j(i) >= 1
      do
        v = j(i);
        bucket{m}(i)= distances(v);
        i++;
      until(i == length(j)+1)
    endif
    m++;  
  until(max(distances) <= bucket_width)
##---frequency-----
  for i=1:length(bucket)
    f(i) = length(bucket{i});
  endfor
#------PDF----
  for i=1:length(f)
    y(i) = f(i)/sum(f);
  endfor    
#------CDF------
  for i=1:length(y)
    y_cdf(i) = sum(y(1:i));
  endfor
#--------inverse_transformation--------
  i=1;
  z = rand;
  m=1;
  if z <= y_cdf(i)
    m = z;
    m = ceil((m / y(i)) * f(i));
    d = bucket{i}(m);
  else 
    do        
      i++;
      if y_cdf(i-1) < z & z <= y_cdf(i)
        m = z - y_cdf(i-1);
        m = ceil((m/y(i)) * f(i));
        d= bucket{i}(m);    
      endif
    until(y_cdf(i-1) < z & z <= y_cdf(i))
  endif  
endfunction
